#!/bin/bash
. /opt/kelvpn/sbin/kelvpn_func.sh
. /opt/kelvpn/etc/KelVPNCheck.conf
wlan="wlan0"
ch="unknown"
quality="unknown"
signal="unknown"
state="init"


score=()
score_quality=()

channels=`iw phy phy2 info |grep MHz | awk '{print $4;}' |sed 's/\[//' | sed 's/\]//'`
for c in $channels; do
    score[c]=0
#    echo "score[$c] = ${score[$c]}"
done

    log_it "Scan on $wlan interface"

min_score=100
min_score_ch=1

    for line in `iwlist wlan0 scan`; do 
	# ---==== Init state ===---
	if [ "$state" = "init" ]; then 
	    if echo $line | grep Channel >>/dev/null; then
		state="channel"
		#log_it_debug "New AP found"
		continue
	    fi
	elif [ "$state" = "channel" ]; then
	    ch=`echo $line | sed 's/)//'`
	    #log_it_debug "Channel $ch"
	    state="quality"
	elif [ "$state" = "quality" ]; then
	    if echo $line |grep Quality >>/dev/null; then
		quality=`echo $line| grep Quality | awk '{print $1;}' | sed 's/Quality=//' | sed 's/\/100//'`
		#log_it_debug "Found quality $quality"
		state="signal"
	    fi
	elif [ "$state" = "signal" ]; then
	    if echo $line |grep Signal >> /dev/null; then
		state="signal_value"
		continue
	    fi
	elif [ "$state" = "signal_value" ]; then
	    signal=`echo $line| sed 's/level=//' | sed 's/\/100//'`
#	    log_it_debug "Found signal $signal"
	    log_it "CH $ch: quality $quality/100,  signal $signal/100"
	    score[$ch]+=$signal
	    score[$(($ch-1))]+=$(($signal/4))
	    score[$(($ch+1))]+=$(($signal/4))
	    #score_quality[$ch]=$quality
	    state="init"
	fi
	
#	if [ "$ch"!="unknown" ] && [ "$ch"!="unknown" ] && [ "$ch"!="unknown" ]; then
#	    log_it_debug "CH $ch: quality $quality,  signal $signal"
#	fi
    done



min_score=1000
min_score_ch=0
min_score_ch_prev=0
for c in $channels; do
    if [[ ${score[$c]}<$min_score ]]; then
	min_score_ch_prev=$min_score_ch
	min_score_ch=$c
	min_score=${score[$c]}
    fi
done

echo "Best channeles are $min_score_ch and $min_score_ch_prev"
sed -i "s/channel=.*/channel=$min_score_ch/" /etc/hostapd/wlan0.conf
sed -i "s/channel=.*/channel=$min_score_ch_prev/" /etc/hostapd/wlan1.conf


