#!/bin/sh

_log_it()
{
    d=`date +%d-%m-%y`
    t=`date +%d-%m-%y_%H:%M:%S`
    log_it_out=/var/log/kelvpn/KelVPNCheck_${d}.log
#    echo "--- log_it_out=$log_it_out ---"
    #log_it_out=/dev/stdout
    echo "[$t] $@" >> $log_it_out
    echo "[$t] $@" 
}

log_it_debug()
{
    t=`date +%d-%m-%y_%H:%M:%S`
    echo "[$t] [ ] $@" 
    #_log_it "[ ] $@"
}

log_it()
{
    _log_it "[*] $@"
}

log_it_error()
{
    _log_it "[ERR] $@"
}

log_it_warning()
{
    _log_it "[ERR] $@"
}


log_it_notice()
{
    _log_it "[!!] $@"
}

kelvpn_service_restart()
{
    log_it_debug "Restarting KelVPNService"
    timeout 10 service KelVPNService stop
    killall -9 KelVPNService 2>/dev/null >/dev/null
    timeout 10 service KelVPNService start || exit 2
    if /opt/kelvpn/sbin/kelvpn_check_inet.sh; then
	log_it_debug "Network is present all is good"
    else
	if timeout 10 service networking restart; then
	    log_it_debug "Was no network so we sucessfully restarted the networking service"
	else
	    log_it_error "Can't restart the networking, exit the daemon"
	    exit 2
	fi
    fi
}
