#!/bin/sh
. /opt/kelvpn/sbin/kelvpn_func.sh

ip_list_path="/opt/kelvpn/var/cache"
ip_list="$ip_list_path/$1"

if ! [ -f $ip_list ]; then
    log_it_error "No file $ip_list"
    exit 4
fi
ip_count=`cat $ip_list |wc -l`

ip_step=$(($ip_count/100))
log_it "Hybrid mode $ip_count IP addrsesses to install. Report every $ip_step"
op=$2
#exit 0
n=0

if [ "$op" = "add" ] || [ "$op" = "del" ]; then
    log_it_debug "Selected $op action"
else
    log_it_debug "Action should be \"add\" or \"del\" but not \"$op\""
    exit 1
fi

for ip in `cat $ip_list`; do 
    netmask=`echo $ip|sed s/[0-9.]*//`
    #log_it_debug "ip=$ip netmask=$netmask"
    if [ $netmask = "/32" ];then
	route $op -host $ip dev tun0 2>> /dev/null
	#if ! route $op -host $ip dev tun0; then
	    #log_it_error "Can't $op route for host $ip exit code $?" 
	    #exit 2
	#fi
    else
	route $op -net $ip dev tun0 2>>/dev/null
	#if ! route $op -net $ip dev tun0; then
	#    log_it_error "Can't $op route for network $ip exit code $?" 
	#    exit 2
	#fi
    fi
    if [ $ip_step = "0" ]; then
	    log_it_debug "#$n"
    else
	if [ $((n%$ip_step)) = "0" ]; then 
	    p=$(($n/$ip_step))
	    log_it_debug "$p%"
	fi
    fi
    n=$(($n+1))
done
